<?php
/**
 * Group
 *
 * PHP version 5
 *
 * @category Class
 * @package  OSDN
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2016 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace OSDN\Model;

use \ArrayAccess;
/**
 * Group Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     OSDN
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class Group implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization 
      * @var string[]
      */
    static $swaggerTypes = array(
        'id' => 'int',
        'name' => 'string',
        'display_name' => 'string',
        'last_update' => '\DateTime',
        'description' => 'string',
        'description_html' => 'string',
        'start_date' => '\DateTime',
        'license' => 'string',
        'license_other' => 'string',
        'url' => 'string',
        'homepage' => 'string',
        'logo_image' => 'string',
        'banner_image' => 'string',
        'thumbnail_image' => 'string',
        'tools' => '\OSDN\Model\GroupToolFlags',
        'members' => '\OSDN\Model\SimpleUser[]'
    );
  
    /** 
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[] 
      */
    static $attributeMap = array(
        'id' => 'id',
        'name' => 'name',
        'display_name' => 'display_name',
        'last_update' => 'last_update',
        'description' => 'description',
        'description_html' => 'description_html',
        'start_date' => 'start_date',
        'license' => 'license',
        'license_other' => 'license_other',
        'url' => 'url',
        'homepage' => 'homepage',
        'logo_image' => 'logo_image',
        'banner_image' => 'banner_image',
        'thumbnail_image' => 'thumbnail_image',
        'tools' => 'tools',
        'members' => 'members'
    );
  
    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'id' => 'setId',
        'name' => 'setName',
        'display_name' => 'setDisplayName',
        'last_update' => 'setLastUpdate',
        'description' => 'setDescription',
        'description_html' => 'setDescriptionHtml',
        'start_date' => 'setStartDate',
        'license' => 'setLicense',
        'license_other' => 'setLicenseOther',
        'url' => 'setUrl',
        'homepage' => 'setHomepage',
        'logo_image' => 'setLogoImage',
        'banner_image' => 'setBannerImage',
        'thumbnail_image' => 'setThumbnailImage',
        'tools' => 'setTools',
        'members' => 'setMembers'
    );
  
    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'id' => 'getId',
        'name' => 'getName',
        'display_name' => 'getDisplayName',
        'last_update' => 'getLastUpdate',
        'description' => 'getDescription',
        'description_html' => 'getDescriptionHtml',
        'start_date' => 'getStartDate',
        'license' => 'getLicense',
        'license_other' => 'getLicenseOther',
        'url' => 'getUrl',
        'homepage' => 'getHomepage',
        'logo_image' => 'getLogoImage',
        'banner_image' => 'getBannerImage',
        'thumbnail_image' => 'getThumbnailImage',
        'tools' => 'getTools',
        'members' => 'getMembers'
    );
  
    
    /**
      * $id 
      * @var int
      */
    protected $id;
    
    /**
      * $name 
      * @var string
      */
    protected $name;
    
    /**
      * $display_name 
      * @var string
      */
    protected $display_name;
    
    /**
      * $last_update 
      * @var \DateTime
      */
    protected $last_update;
    
    /**
      * $description 
      * @var string
      */
    protected $description;
    
    /**
      * $description_html 
      * @var string
      */
    protected $description_html;
    
    /**
      * $start_date 
      * @var \DateTime
      */
    protected $start_date;
    
    /**
      * $license 
      * @var string
      */
    protected $license;
    
    /**
      * $license_other 
      * @var string
      */
    protected $license_other;
    
    /**
      * $url 
      * @var string
      */
    protected $url;
    
    /**
      * $homepage 
      * @var string
      */
    protected $homepage;
    
    /**
      * $logo_image 
      * @var string
      */
    protected $logo_image;
    
    /**
      * $banner_image 
      * @var string
      */
    protected $banner_image;
    
    /**
      * $thumbnail_image 
      * @var string
      */
    protected $thumbnail_image;
    
    /**
      * $tools 
      * @var \OSDN\Model\GroupToolFlags
      */
    protected $tools;
    
    /**
      * $members 
      * @var \OSDN\Model\SimpleUser[]
      */
    protected $members;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            $this->id = $data["id"];
            $this->name = $data["name"];
            $this->display_name = $data["display_name"];
            $this->last_update = $data["last_update"];
            $this->description = $data["description"];
            $this->description_html = $data["description_html"];
            $this->start_date = $data["start_date"];
            $this->license = $data["license"];
            $this->license_other = $data["license_other"];
            $this->url = $data["url"];
            $this->homepage = $data["homepage"];
            $this->logo_image = $data["logo_image"];
            $this->banner_image = $data["banner_image"];
            $this->thumbnail_image = $data["thumbnail_image"];
            $this->tools = $data["tools"];
            $this->members = $data["members"];
        }
    }
    
    /**
     * Gets id
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
  
    /**
     * Sets id
     * @param int $id 
     * @return $this
     */
    public function setId($id)
    {
        
        $this->id = $id;
        return $this;
    }
    
    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
  
    /**
     * Sets name
     * @param string $name 
     * @return $this
     */
    public function setName($name)
    {
        
        $this->name = $name;
        return $this;
    }
    
    /**
     * Gets display_name
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }
  
    /**
     * Sets display_name
     * @param string $display_name 
     * @return $this
     */
    public function setDisplayName($display_name)
    {
        
        $this->display_name = $display_name;
        return $this;
    }
    
    /**
     * Gets last_update
     * @return \DateTime
     */
    public function getLastUpdate()
    {
        return $this->last_update;
    }
  
    /**
     * Sets last_update
     * @param \DateTime $last_update 
     * @return $this
     */
    public function setLastUpdate($last_update)
    {
        
        $this->last_update = $last_update;
        return $this;
    }
    
    /**
     * Gets description
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }
  
    /**
     * Sets description
     * @param string $description 
     * @return $this
     */
    public function setDescription($description)
    {
        
        $this->description = $description;
        return $this;
    }
    
    /**
     * Gets description_html
     * @return string
     */
    public function getDescriptionHtml()
    {
        return $this->description_html;
    }
  
    /**
     * Sets description_html
     * @param string $description_html 
     * @return $this
     */
    public function setDescriptionHtml($description_html)
    {
        
        $this->description_html = $description_html;
        return $this;
    }
    
    /**
     * Gets start_date
     * @return \DateTime
     */
    public function getStartDate()
    {
        return $this->start_date;
    }
  
    /**
     * Sets start_date
     * @param \DateTime $start_date 
     * @return $this
     */
    public function setStartDate($start_date)
    {
        
        $this->start_date = $start_date;
        return $this;
    }
    
    /**
     * Gets license
     * @return string
     */
    public function getLicense()
    {
        return $this->license;
    }
  
    /**
     * Sets license
     * @param string $license 
     * @return $this
     */
    public function setLicense($license)
    {
        
        $this->license = $license;
        return $this;
    }
    
    /**
     * Gets license_other
     * @return string
     */
    public function getLicenseOther()
    {
        return $this->license_other;
    }
  
    /**
     * Sets license_other
     * @param string $license_other 
     * @return $this
     */
    public function setLicenseOther($license_other)
    {
        
        $this->license_other = $license_other;
        return $this;
    }
    
    /**
     * Gets url
     * @return string
     */
    public function getUrl()
    {
        return $this->url;
    }
  
    /**
     * Sets url
     * @param string $url 
     * @return $this
     */
    public function setUrl($url)
    {
        
        $this->url = $url;
        return $this;
    }
    
    /**
     * Gets homepage
     * @return string
     */
    public function getHomepage()
    {
        return $this->homepage;
    }
  
    /**
     * Sets homepage
     * @param string $homepage 
     * @return $this
     */
    public function setHomepage($homepage)
    {
        
        $this->homepage = $homepage;
        return $this;
    }
    
    /**
     * Gets logo_image
     * @return string
     */
    public function getLogoImage()
    {
        return $this->logo_image;
    }
  
    /**
     * Sets logo_image
     * @param string $logo_image 
     * @return $this
     */
    public function setLogoImage($logo_image)
    {
        
        $this->logo_image = $logo_image;
        return $this;
    }
    
    /**
     * Gets banner_image
     * @return string
     */
    public function getBannerImage()
    {
        return $this->banner_image;
    }
  
    /**
     * Sets banner_image
     * @param string $banner_image 
     * @return $this
     */
    public function setBannerImage($banner_image)
    {
        
        $this->banner_image = $banner_image;
        return $this;
    }
    
    /**
     * Gets thumbnail_image
     * @return string
     */
    public function getThumbnailImage()
    {
        return $this->thumbnail_image;
    }
  
    /**
     * Sets thumbnail_image
     * @param string $thumbnail_image 
     * @return $this
     */
    public function setThumbnailImage($thumbnail_image)
    {
        
        $this->thumbnail_image = $thumbnail_image;
        return $this;
    }
    
    /**
     * Gets tools
     * @return \OSDN\Model\GroupToolFlags
     */
    public function getTools()
    {
        return $this->tools;
    }
  
    /**
     * Sets tools
     * @param \OSDN\Model\GroupToolFlags $tools 
     * @return $this
     */
    public function setTools($tools)
    {
        
        $this->tools = $tools;
        return $this;
    }
    
    /**
     * Gets members
     * @return \OSDN\Model\SimpleUser[]
     */
    public function getMembers()
    {
        return $this->members;
    }
  
    /**
     * Sets members
     * @param \OSDN\Model\SimpleUser[] $members 
     * @return $this
     */
    public function setMembers($members)
    {
        
        $this->members = $members;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset 
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }
  
    /**
     * Gets offset.
     * @param  integer $offset Offset 
     * @return mixed 
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }
  
    /**
     * Sets value based on offset.
     * @param  integer $offset Offset 
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }
  
    /**
     * Unsets offset.
     * @param  integer $offset Offset 
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }
  
    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this));
        }
    }
}
