<?php
/**
 * User
 *
 * PHP version 5
 *
 * @category Class
 * @package  OSDN
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2016 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace OSDN\Model;

use \ArrayAccess;
/**
 * User Class Doc Comment
 *
 * @category    Class
 * @description 
 * @package     OSDN
 * @author      http://github.com/swagger-api/swagger-codegen
 * @license     http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class User implements ArrayAccess
{
    /**
      * Array of property to type mappings. Used for (de)serialization 
      * @var string[]
      */
    static $swaggerTypes = array(
        'id' => 'int',
        'name' => 'string',
        'display_name' => 'string',
        'unix_status' => 'bool',
        'unix_uid' => 'int',
        'authorized_keys' => 'string',
        'timezone' => 'string',
        'last_update' => '\DateTime',
        'add_date' => '\DateTime',
        'language' => 'string',
        'groups' => '\OSDN\Model\SimpleGroup[]',
        'chambers' => '\OSDN\Model\SimpleChamber[]',
        'skills' => '\OSDN\Model\Skill[]'
    );
  
    /** 
      * Array of attributes where the key is the local name, and the value is the original name
      * @var string[] 
      */
    static $attributeMap = array(
        'id' => 'id',
        'name' => 'name',
        'display_name' => 'display_name',
        'unix_status' => 'unix_status',
        'unix_uid' => 'unix_uid',
        'authorized_keys' => 'authorized_keys',
        'timezone' => 'timezone',
        'last_update' => 'last_update',
        'add_date' => 'add_date',
        'language' => 'language',
        'groups' => 'groups',
        'chambers' => 'chambers',
        'skills' => 'skills'
    );
  
    /**
      * Array of attributes to setter functions (for deserialization of responses)
      * @var string[]
      */
    static $setters = array(
        'id' => 'setId',
        'name' => 'setName',
        'display_name' => 'setDisplayName',
        'unix_status' => 'setUnixStatus',
        'unix_uid' => 'setUnixUid',
        'authorized_keys' => 'setAuthorizedKeys',
        'timezone' => 'setTimezone',
        'last_update' => 'setLastUpdate',
        'add_date' => 'setAddDate',
        'language' => 'setLanguage',
        'groups' => 'setGroups',
        'chambers' => 'setChambers',
        'skills' => 'setSkills'
    );
  
    /**
      * Array of attributes to getter functions (for serialization of requests)
      * @var string[]
      */
    static $getters = array(
        'id' => 'getId',
        'name' => 'getName',
        'display_name' => 'getDisplayName',
        'unix_status' => 'getUnixStatus',
        'unix_uid' => 'getUnixUid',
        'authorized_keys' => 'getAuthorizedKeys',
        'timezone' => 'getTimezone',
        'last_update' => 'getLastUpdate',
        'add_date' => 'getAddDate',
        'language' => 'getLanguage',
        'groups' => 'getGroups',
        'chambers' => 'getChambers',
        'skills' => 'getSkills'
    );
  
    
    /**
      * $id 
      * @var int
      */
    protected $id;
    
    /**
      * $name 
      * @var string
      */
    protected $name;
    
    /**
      * $display_name 
      * @var string
      */
    protected $display_name;
    
    /**
      * $unix_status 
      * @var bool
      */
    protected $unix_status;
    
    /**
      * $unix_uid 
      * @var int
      */
    protected $unix_uid;
    
    /**
      * $authorized_keys 
      * @var string
      */
    protected $authorized_keys;
    
    /**
      * $timezone 
      * @var string
      */
    protected $timezone;
    
    /**
      * $last_update 
      * @var \DateTime
      */
    protected $last_update;
    
    /**
      * $add_date 
      * @var \DateTime
      */
    protected $add_date;
    
    /**
      * $language 
      * @var string
      */
    protected $language;
    
    /**
      * $groups 
      * @var \OSDN\Model\SimpleGroup[]
      */
    protected $groups;
    
    /**
      * $chambers 
      * @var \OSDN\Model\SimpleChamber[]
      */
    protected $chambers;
    
    /**
      * $skills 
      * @var \OSDN\Model\Skill[]
      */
    protected $skills;
    

    /**
     * Constructor
     * @param mixed[] $data Associated array of property value initalizing the model
     */
    public function __construct(array $data = null)
    {
        if ($data != null) {
            $this->id = $data["id"];
            $this->name = $data["name"];
            $this->display_name = $data["display_name"];
            $this->unix_status = $data["unix_status"];
            $this->unix_uid = $data["unix_uid"];
            $this->authorized_keys = $data["authorized_keys"];
            $this->timezone = $data["timezone"];
            $this->last_update = $data["last_update"];
            $this->add_date = $data["add_date"];
            $this->language = $data["language"];
            $this->groups = $data["groups"];
            $this->chambers = $data["chambers"];
            $this->skills = $data["skills"];
        }
    }
    
    /**
     * Gets id
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }
  
    /**
     * Sets id
     * @param int $id 
     * @return $this
     */
    public function setId($id)
    {
        
        $this->id = $id;
        return $this;
    }
    
    /**
     * Gets name
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
  
    /**
     * Sets name
     * @param string $name 
     * @return $this
     */
    public function setName($name)
    {
        
        $this->name = $name;
        return $this;
    }
    
    /**
     * Gets display_name
     * @return string
     */
    public function getDisplayName()
    {
        return $this->display_name;
    }
  
    /**
     * Sets display_name
     * @param string $display_name 
     * @return $this
     */
    public function setDisplayName($display_name)
    {
        
        $this->display_name = $display_name;
        return $this;
    }
    
    /**
     * Gets unix_status
     * @return bool
     */
    public function getUnixStatus()
    {
        return $this->unix_status;
    }
  
    /**
     * Sets unix_status
     * @param bool $unix_status 
     * @return $this
     */
    public function setUnixStatus($unix_status)
    {
        
        $this->unix_status = $unix_status;
        return $this;
    }
    
    /**
     * Gets unix_uid
     * @return int
     */
    public function getUnixUid()
    {
        return $this->unix_uid;
    }
  
    /**
     * Sets unix_uid
     * @param int $unix_uid 
     * @return $this
     */
    public function setUnixUid($unix_uid)
    {
        
        $this->unix_uid = $unix_uid;
        return $this;
    }
    
    /**
     * Gets authorized_keys
     * @return string
     */
    public function getAuthorizedKeys()
    {
        return $this->authorized_keys;
    }
  
    /**
     * Sets authorized_keys
     * @param string $authorized_keys 
     * @return $this
     */
    public function setAuthorizedKeys($authorized_keys)
    {
        
        $this->authorized_keys = $authorized_keys;
        return $this;
    }
    
    /**
     * Gets timezone
     * @return string
     */
    public function getTimezone()
    {
        return $this->timezone;
    }
  
    /**
     * Sets timezone
     * @param string $timezone 
     * @return $this
     */
    public function setTimezone($timezone)
    {
        
        $this->timezone = $timezone;
        return $this;
    }
    
    /**
     * Gets last_update
     * @return \DateTime
     */
    public function getLastUpdate()
    {
        return $this->last_update;
    }
  
    /**
     * Sets last_update
     * @param \DateTime $last_update 
     * @return $this
     */
    public function setLastUpdate($last_update)
    {
        
        $this->last_update = $last_update;
        return $this;
    }
    
    /**
     * Gets add_date
     * @return \DateTime
     */
    public function getAddDate()
    {
        return $this->add_date;
    }
  
    /**
     * Sets add_date
     * @param \DateTime $add_date 
     * @return $this
     */
    public function setAddDate($add_date)
    {
        
        $this->add_date = $add_date;
        return $this;
    }
    
    /**
     * Gets language
     * @return string
     */
    public function getLanguage()
    {
        return $this->language;
    }
  
    /**
     * Sets language
     * @param string $language 
     * @return $this
     */
    public function setLanguage($language)
    {
        
        $this->language = $language;
        return $this;
    }
    
    /**
     * Gets groups
     * @return \OSDN\Model\SimpleGroup[]
     */
    public function getGroups()
    {
        return $this->groups;
    }
  
    /**
     * Sets groups
     * @param \OSDN\Model\SimpleGroup[] $groups 
     * @return $this
     */
    public function setGroups($groups)
    {
        
        $this->groups = $groups;
        return $this;
    }
    
    /**
     * Gets chambers
     * @return \OSDN\Model\SimpleChamber[]
     */
    public function getChambers()
    {
        return $this->chambers;
    }
  
    /**
     * Sets chambers
     * @param \OSDN\Model\SimpleChamber[] $chambers 
     * @return $this
     */
    public function setChambers($chambers)
    {
        
        $this->chambers = $chambers;
        return $this;
    }
    
    /**
     * Gets skills
     * @return \OSDN\Model\Skill[]
     */
    public function getSkills()
    {
        return $this->skills;
    }
  
    /**
     * Sets skills
     * @param \OSDN\Model\Skill[] $skills 
     * @return $this
     */
    public function setSkills($skills)
    {
        
        $this->skills = $skills;
        return $this;
    }
    
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset 
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->$offset);
    }
  
    /**
     * Gets offset.
     * @param  integer $offset Offset 
     * @return mixed 
     */
    public function offsetGet($offset)
    {
        return $this->$offset;
    }
  
    /**
     * Sets value based on offset.
     * @param  integer $offset Offset 
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        $this->$offset = $value;
    }
  
    /**
     * Unsets offset.
     * @param  integer $offset Offset 
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->$offset);
    }
  
    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) {
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        } else {
            return json_encode(\OSDN\ObjectSerializer::sanitizeForSerialization($this));
        }
    }
}
